/**
* modpword.c
*
* Allow the Password in the file PASSWORD.SYS to be Changed
* This program will first read in the ENTIRE PASSWORD.SYS file
* and extract the up to sixteen (16) characters of the password.
* The Password MUST be retyped exactly to be changed.
* The PASSWORD.SYS file is then written back out to the disk.
* This program will display all of the keyed characters and passwords
*
* I apologize for this not being a "clear" piece of 'C' code
* but strings and I are still having problems.
*
* This program was written using Lattice ver 2.14 'C' Compiler
* 
*  Garth Kennedy    25 February 1985
**/
#include "_main.c"

main()
{
    static char pass[400];   /* data file for PASSWORD.SYS */
    static char *passf = "PASSWORD.SYS"; /* file name */
    char *p;                 /* pointer to first block of data */
    FILE *fp;                /* file pointer */
    int nact;                /* number of blocks read/written */
    int n;                   /* number of blocks to be read/written */
    int s;                   /* size of each block, in bytes */
    char *mode = "rb+";        /* read/write a file -untranslated */
    int ret;                  /* return code */
    static char pw1[20],pw2[20];   /* temp holding for new passwords */
    int i,j,k,l,pwl1,pwl2;
    char c,d;
     
    s = 0x012B;                /* size of PASSWORD.SYS */
    n = 1;                   /* one block to be read */
    p = &pass[0];            /* pointer to beginning of data file */
    fp = fopen(passf,mode);    /* open the file */
    nact = fread(p,s,n,fp);     /* read data block from disc */
    ret = fclose(fp);       /* close the disc file */  

                     /* Print out the CRT Header */
    printf("   Change the Password Program               25 February 1985\n\n");
    printf("         This program is in the public domain, the program may\n");
    printf("         be copied and used without charge.\n");
    printf("                   Copyright  KJ Consulting 1985\n\n");

    printf("\n       This program will allow the password to be changed\n");
    printf("\n       in the password program PASSWORD.SYS.\n"); 
    printf("\n       You will be asked to 1.) Enter the current Password\n");
    printf("                            2.) Enter the New Password\n");
    printf("                            3.) Reenter the New Password\n");
    printf("\n       ");  
    printf("\n       At any point at which the Passwords dont match this program\n");
    printf("       will terminate\n\n\n");

    pwl1 = pass[0x0F];            /* length of old (#1) password */
    pw1[0] = pass[0x10],pw1[1] = pass[0x11],pw1[2] = pass[0x12];
    pw1[3] = pass[0x13],pw1[4] = pass[0x14],pw1[5] = pass[0x15]; 
    pw1[6] = pass[0x16],pw1[7] = pass[0x17],pw1[8] = pass[0x18];
    pw1[9] = pass[0x19],pw1[10] = pass[0x1A],pw1[11] = pass[0x1B]; 
    pw1[12] = pass[0x1C],pw1[13] = pass[0x1D],pw1[14] = pass[0x1E];
    pw1[15] = pass[0x1F];

    printf("The current Password is - ");
    for (i = 0;i < pwl1;i++)
        printf("%c",pw1[i]);
    printf("\n");
    printf("The Password in HEX Notation is ");
    for (i = 0;i < pwl1;i++)
        printf("%x ",pw1[i]);
    printf("\n");

    i = 0,j = 0,l = 0;
    printf("Please enter the Current Password - ");
    for (i = 0;i <= 15;i++)       /* manually enter to confirm */
    {
        c = getch();         /* check char by char */
        if (c == 0x0D || c == 0x0A)  break; /* carriage return entered - end */
        if (c != pw1[i])     /* j will be non-zero if wrong */
            j++;
        printf("%c",c);
    }
    printf("\n");
/*    i = i - 1;   */
    if ( i != pwl1)  j++;                    /* lengths dont match */
    if (j != 0 )                /* didnt match */ 
    {
        printf("\n\n  !!! SORRY !!!  Wrong Password Entered \n\n");
        exit(); 
    }
    while (l == 0)
    {
        printf("\nPlease Enter the New Password. Press Enter to Stop - ");
        for (i = 0;i < 16;i++)
        {
            pw2[i] = getch();
            if (pw2[i] == 0x0A || pw2[i] == 0x0D)
            {
                pwl2 = i;
                pw2[i] = 0x20;
                break;
            }
            printf("%c",pw2[i]);
        }
        printf("\n");
        
        j = 0;
        printf("Please Reenter the New Password - ");
        for (i = 0;i < 16;i++)       /* manually enter to confirm */
        {
            c = getch();             /* check reentry char by char */
            if (c == 0x0A || c == 0x0D)
            {
                if (i == pwl2)
                    break;
                else
                {
                    j = 999;      /* no match in length */
                    break;
                }
            }        
            if (c != pw2[i])  j++;   /* j non-zero if no match */
            printf("%c",c);
        }
        printf("\n");
        if (j == 0)
            l = 999;            /* new password checks */
    }                          /* end of if l == 0 */
                        /* if j non-zero repeat the whole new password */
                        /* entry - vlaues will need to be reentered */

    printf("Saving the new Password\n\n");  /* passwords matched */

    pass[0x0F] = pwl2;            /* length of new (#2) password */
    pass[0x10] = pw2[0],pass[0x11] = pw2[1],pass[0x12] = pw2[2];
    pass[0x13] = pw2[3],pass[0x14] = pw2[4],pass[0x15] = pw2[5]; 
    pass[0x16] = pw2[6],pass[0x17] = pw2[7],pass[0x18] = pw2[8];
    pass[0x19] = pw2[9],pass[0x1A] = pw2[10],pass[0x1B] = pw2[11]; 
    pass[0x1C] = pw2[12],pass[0x1D] = pw2[13],pass[0x1E] = pw2[14];
    pass[0x1F] = pw2[15];

    s = 0x012B;              /* size of PASSWRD.COM */
    n = 1;                   /* one block to be read */
    p = &pass[0];            /* pointer to beginning of data file */
    fp = fopen(passf,mode);    /* open the file */
    nact = fwrite(p,s,n,fp);     /* read data block from disc */
    ret = fclose(fp);       /* close the disc file */  

    exit();
}

